<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:h="jakarta.faces.html"
	xmlns:f="jakarta.faces.core"
	xmlns:pt="jakarta.faces.passthrough"
	xmlns:jsf="jakarta.faces"
	xmlns:ui="jakarta.faces.facelets"
	xmlns:p="http://primefaces.org/ui">

	<f:view contentType="text/html" locale="pt_BR">
		<h:head>
		</h:head> 
		<h:body>
			<div class="card">
				<h:form id="form">
					<p:growl id="messages" showDetail="true" />
		
					<p:toolbar>
						<p:toolbarGroup>
							<p:commandButton
								value="Cadastrar"
								icon="pi pi-plus"
								actionListener="#{personView.openNew}"
								update=":dialogs:manage-person-content"
								oncomplete="PF('managePersonDialog').show()"
								styleClass="ui-button-success"
								style="margin-right: .5rem">
								<p:resetInput target=":dialogs:manage-person-content" />
							</p:commandButton>
		
							<p:commandButton
								id="delete-persons-button"
								value="#{personView.deleteButtonMessage}"
								icon="pi pi-trash"
								actionListener="#{personView.deleteSelectedPersons}"
								styleClass="ui-button-danger"
								disabled="#{!personView.hasSelectedPersons()}"
								update="@this">
								
								<p:confirm
									header="Confirmação"
									message="Remover pessoas selecionadas?"
									icon="pi pi-exclamation-triangle"/>
							</p:commandButton>
						</p:toolbarGroup>
					</p:toolbar>
		
					<p:dataTable
						id="dt-persons"
						widgetVar="dtPersons"
						var="person"
						value="#{personView.persons}"
						selection="#{personView.selectedPersons}"
						reflow="true"
						rowKey="#{person.id}"
						paginator="true"
						rows="10"
						rowSelectMode="add"
						paginatorPosition="bottom">
		
						<f:facet name="header">
							<div class="persons-table-header">
								<span style="font-weight: bold">Lista de Pessoas</span>
							</div>
						</f:facet>
		
						<p:ajax event="rowSelect" update=":form:delete-persons-button" />
						<p:ajax event="rowUnselect" update=":form:delete-persons-button" />
						<p:ajax event="rowSelectCheckbox" update=":form:delete-persons-button" />
						<p:ajax event="rowUnselectCheckbox" update=":form:delete-persons-button" />
						<p:ajax event="toggleSelect" update=":form:delete-persons-button" />
		
						<p:column selectionMode="multiple" exportable="false"></p:column>
		
						<p:column
							headerText="Nome"
							sortBy="#{person.name}">
							<h:outputText value="#{person.name}" />
						</p:column>
		
						<p:column
							headerText="Sexo"
							sortBy="#{person.gender}">
							<h:outputText value="#{person.gender.gender}" />
						</p:column>
		
						<p:column
							headerText="Nascimento"
							sortBy="#{person.birth}">
							<h:outputText value="#{person.birth}" />
						</p:column>
		
						<p:column
							headerText="Cidade"
							sortBy="#{person.city}">
							<h:outputText value="#{person.city}" />
						</p:column>
		
						<p:column
							headerText="Estado"
							sortBy="#{person.state}">
							<h:outputText value="#{person.state}" />
						</p:column>
		
						<p:column exportable="false">
							<p:commandButton
								icon="pi pi-pencil"
								update=":dialogs:manage-person-content"
								oncomplete="PF('managePersonDialog').show()"
								styleClass="edit-button rounded-button ui-button-success"
								process="@this"
								action="#{personView.editPerson}">
								<f:setPropertyActionListener
									value="#{person}"
									target="#{personView.personResponse}" />
								
								<p:resetInput target=":dialogs:manage-person-content" />
							</p:commandButton>
		
							<p:commandButton
								class="ui-button-warning rounded-button"
								icon="pi pi-trash"
								process="@this"
								oncomplete="PF('deletePersonDialog').show()">
								<f:setPropertyActionListener
									value="#{person}"
									target="#{personView.personResponse}" />
							</p:commandButton>
						</p:column>
		
					</p:dataTable>
				</h:form>
		
				<h:form id="dialogs">
					<p:dialog
						header="Detalhes da Pessoa"
						showEffect="fade"
						modal="true"
						widgetVar="managePersonDialog"
						responsive="true">
						<p:outputPanel
							id="manage-person-content"
							class="ui-fluid">
							<style>
								body .ui-panelgrid .ui-panelgrid-cell {
									background-color: transparent;
								}
							
								.my-heading-row {
									background-color: var(--surface-c);
									font-weight: bold;
								}
							</style>

							<div class="formgrid grid">
							
								<p:row styleClass="my-heading-row">
									Dados Pessoais
								</p:row>

								<p:outputLabel for="name" value="Name" />
								<p:inputText id="name" value="#{personView.personForm.name}" required="true" />
								
								<p:outputLabel for="button" value="Nascimento" />
								<p:datePicker id="button" value="#{personView.personForm.birth}" pattern="dd/MM/yyyy" locale="pt" showIcon="true" />
								
								<p:outputLabel for="gender" value="Sexo" />
								<p:selectOneRadio id="gender" value="#{personView.personForm.gender}" layout="responsive" columns="2">
							
									<f:selectItems value="#{personView.genders}" var="gender" itemLabel="#{gender.gender}"
										itemValue="#{gender.name}" />
								</p:selectOneRadio>
								
							
								<p:row id="my-row-id" styleClass="my-heading-row">
									Endereço
								</p:row>
							
								<p:outputLabel for="state" value="Estado" />
								<p:inputText id="state" value="#{personView.personForm.state}" required="true" />

								<p:outputLabel for="city" value="Cidade" />
								<p:inputText id="city" value="#{personView.personForm.city}" required="true" />

								<p:outputLabel for="address" value="Logradouro" />
								<p:inputText id="address" value="#{personView.personForm.address}" required="true" />

								<p:outputLabel for="number" value="Número" />
								<p:inputText id="number" value="#{personView.personForm.number}" required="true" />

								<p:outputLabel for="zipcode" value="CEP" />
								<p:inputText id="zipcode" value="#{personView.personForm.zipcode}" required="true" />
							
							</div>
						</p:outputPanel>
		
						<f:facet name="footer">
							<p:commandButton
								value="Salvar"
								icon="pi pi-check"
								actionListener="#{personView.savePerson}"
								update="manage-person-content"
								process="manage-person-content @this" />
		
							<p:commandButton
								value="Cancelar"
								icon="pi pi-times"
								onclick="PF('managePersonDialog').hide()"
								class="ui-button-secondary"
								type="button" />
						</f:facet>
					</p:dialog>
		
					<p:confirmDialog
						widgetVar="deletePersonDialog"
						showEffect="fade"
						width="300"
						message="Deletar pessoa?"
						header="Confirmar"
						severity="warn">
		
						<p:commandButton
							value="Sim"
							icon="pi pi-check"
							actionListener="#{personView.removePerson}"
							process="@this"
							update=":form:delete-persons-button"
							oncomplete="PF('deletePersonDialog').hide()" />
						
						<p:commandButton
							value="Não"
							type="button"
							styleClass="ui-button-secondary"
							icon="pi pi-times"
							onclick="PF('deletePersonDialog').hide()" />
					</p:confirmDialog>
		
					<p:confirmDialog
						global="true"
						showEffect="fade"
						width="300">
						
						<p:commandButton
							value="Sim"
							type="button"
							styleClass="ui-confirmdialog-yes"
							icon="pi pi-check" />
						
						<p:commandButton
							value="Não"
							type="button"
							styleClass="ui-confirmdialog-no ui-button-secondary"
							icon="pi pi-times" />
					</p:confirmDialog>
		
				</h:form>
			</div>
		</h:body> 
	</f:view>
</html>
